#include "mbed.h"
#include "SDFileSystem.h"

                             

AnalogIn x(PTB0);                               //conversion analoga digital
AnalogIn y(PTB1);                               //conversion analoga digital
AnalogIn z(PTB2);                               //conversion analoga digital
SDFileSystem sd(PTD2,PTD3,PTD1,PTD0, "sd");     //objeto de la clase SDFileSystem 
Serial xbee(USBTX,USBRX);                        //comunicacion USB-SERIAL
FILE  *file1;                                   //objeto de la clase FILE (archivo)

char readvar[512];
char sent[64];
char recv[64];
char numero[64];
char home;
float n;
Timer tempo; //activar el modo temporizador
int tiadc,tfadc,tixb,tfxb; //variables para almacenar el temporizador

int main() {
    
    xbee.baud(9600);
    tempo.start();          //inicio del temporizador
    xbee.printf("Presione m para realizar la ADC\n\r");
    xbee.printf("Presione r para realizar la transmision de datos\n\r");
    xbee.printf("Presione t para visualizar el tiempo\n\r");
 
    while(1) {
        char c = xbee.getc();
        if((c == 'm')) {
            
            file1=fopen("/sd/eje x.doc","w"); // para abrir el archivo en modo escritura
            xbee.printf("\nintroduzca numero de tiras   ");
            xbee.scanf("%s",numero);
            n=atoi(numero);
            tiadc=tempo.read_us();  //almacena el dato en el que esta el temporizador
            for(int tira=0;tira<n; tira++)
            {
                for(int i=0; i<42; i++) //ciclo for repite 5 veces
                {
                    fprintf(file1,"%f\n ",x.read());     //escribir en el archivo 1
                    fprintf(file1,"%f\n ",y.read());     //escribir en el archivo 2
                    fprintf(file1,"%f\n ",z.read());     //escribir en el archivo 3
                }
            }
            tfadc=tempo.read_us();     //almacena el dato en el que esta el temporizador
            fclose(file1);                  //cerrar el archivo
            xbee.printf("fin de la convercion analogo digital\n\r");
            }
            
        if((c == 'r')) {
            
            file1=fopen("/sd/eje x.doc","r"); // para abrir el archivo en modo lectura
            tixb=tempo.read_us();
            for(int tira=0;tira<n; tira++)
            {
                for(int i=0; i<42; i++)            //lee 5 datos de cada archivo
                { 
                    fscanf(file1, "\n\r%s", readvar); 
                    xbee.printf("%s", readvar );  
                    fscanf(file1, "\n\r%s", readvar); 
                    xbee.printf("%s", readvar );   
                    fscanf(file1, "\n\r%s", readvar); 
                    xbee.printf("%s", readvar );  
                }              
            }
            tfxb=tempo.read_us();
            fclose(file1); 
            xbee.printf("\n\rtransmision realizada exitosamente\n\r");
            }
             
        if((c == 't')) {
            
            xbee.printf("\n\rtiempo aproximado de la ADC: %d us\n\r",tfadc-tiadc); //mostrar el tiempo utilizado en la adc
            xbee.printf("tiempo aproximado de transmision: %d us\n\r",tfxb-tixb); //mostrar el tiempo utilizado en la transmision
        } 
    }
    
}